static BYTE8 a,status,lastStatus,pa,pb,pc,ca,cb,cs,sr,cl,sl,_temp;
static BYTE8 dataMemory[128];

//so we don't have to shift and or x and y
union {
    BYTE8 both;
    struct {
        BYTE8 y:4;
        BYTE8 x:3;
        BYTE8 :1;
    };
} xy;

static void tms1100reset() {
 ca = cb = cs = 0;
 pa = pb = 0xF;pc = 0;

 //clear O outputs
 LATA=opla[0];

 //clear R outputs
 LATD=0;
 LATE=0;

 a = a & 0xF;xy.x = xy.x & 7;xy.y = xy.y & 0xF;sr = sr & 0x3F;
 cl = cl & 1;sl = sl & 1;lastStatus = lastStatus & 1;
 status = status & 1;
 for (int i = 0;i <= 0x80;i++)
    dataMemory[i] = dataMemory[i] & 0xF;
}
