// open serial for debug output, test port pins (I had an 18F46K22 with 4 bad port pins!)
    char buf[60];
    int lineno=0;

    Open1USART(USART_TX_INT_OFF|USART_RX_INT_OFF|USART_ASYNCH_MODE|USART_EIGHT_BIT|USART_CONT_RX|USART_BRGH_HIGH,15);    //baud=Fosc/(16*(spbrg+1)) @64MHz, 15=250000 baud
    baud1USART(BAUD_8_BIT_RATE|BAUD_AUTO_OFF);
    TXCKP=1;    //invert serial so no MAX232 needed
    RXDTP=1;

    strcpy(buf,"UUUUUUUU");
    while(Busy1USART())
        ;
    puts1USART(buf);

    strcpy(buf,"\nTMS1100\n");
    while(Busy1USART())
        ;
    puts1USART(buf);

    sprintf(buf,"timeout h,l:%d %d\n",INST_TIMEOUT_H,INST_TIMEOUT_L);
    while(Busy1USART())
        ;
    puts1USART(buf);

    sprintf(buf,"testing xy union\n");
    while(Busy1USART())
        ;
    puts1USART(buf);

    xy.x=0;
    xy.y=0;
    sprintf(buf,"0 0 x:%d y:%d xy:%d\n",xy.x,xy.y,xy.both);
    while(Busy1USART())
        ;
    puts1USART(buf);

    xy.x=1;
    xy.y=2;
    sprintf(buf,"1 2 x:%d y:%d xy:%d\n",xy.x,xy.y,xy.both);
    while(Busy1USART())
        ;
    puts1USART(buf);

    xy.x=7;
    xy.y=0xf;
    sprintf(buf,"7 f x:%d y:%d xy:%d\n",xy.x,xy.y,xy.both);
    while(Busy1USART())
        ;
    puts1USART(buf);

    xy.x++;
    xy.y++;
    sprintf(buf,"7+1 f+1 x:%d y:%d xy:%d\n",xy.x,xy.y,xy.both);
    while(Busy1USART())
        ;
    puts1USART(buf);

    xy.x=0;
    xy.y=0;
    xy.x--;
    xy.y--;
    sprintf(buf,"0-1 0-1 x:%d y:%d xy:%d\n",xy.x,xy.y,xy.both);
    while(Busy1USART())
        ;
    puts1USART(buf);

    xy.x=7;
    xy.y=0;
    xy.x++;
    sprintf(buf,"7+1 0 x:%d y:%d xy:%d\n",xy.x,xy.y,xy.both);
    while(Busy1USART())
        ;
    puts1USART(buf);

    sprintf(buf,"testing ports\n");
    while(Busy1USART())
        ;
    puts1USART(buf);

    for(BYTE8 i=1;i<=8;i*=2) {
        LATC^=1;
        LATA=i;
        __delay_us(10);

        sprintf(buf,"PORTA=%d\n",i);
        while(Busy1USART())
            ;
    }
    LATA=0xf;

    for(BYTE8 i=1;i;i*=2) {
        LATC^=1;
        LATD=i;
        __delay_us(10);

        sprintf(buf,"PORTD=%d\n",i);
        while(Busy1USART())
            ;
    }

    LATD=0xff;

    for(BYTE8 i=1;i<=4;i*=2) {
        LATC^=1;
        LATE=i;
        __delay_us(10);

        sprintf(buf,"PORTE=%d\n",i);
        while(Busy1USART())
            ;
    }
    LATE=7;

    sprintf(buf,"starting emulator!\n\n");
    while(Busy1USART())
        ;
    puts1USART(buf);

