if(opcode.and80) {                            //1xxxxxxx = $80-$FF
    if(opcode.and40) {                        //11xxxxxx=CALL
        if(lastStatus) {
            if (cl == 0){
                cs = ca;ca = cb;
                _temp = pa;pa = pb;pb = _temp;
                sr = pc;pc = invlsfr[opcode.and3f];
                cl = 1;
            } else {
                ca = cb;pb = pa;pc = invlsfr[opcode.and3f];
            }
        }
    } else {                                    //10xxxxxx=BR
        if(lastStatus) {
            if (cl == 0){
                ca = cb;pa = pb;pc = invlsfr[opcode.and3f];
            } else {
                ca = cb;pc = invlsfr[opcode.and3f];
            }
        }
    }
} else if(opcode.and40) {                     //01xxxxxx = $40-$7F
    if((opcode.andf0)==ANDF0_0x40) {                  //tcy
        xy.y=rev4bits[opcode.and0f];
    } else if((opcode.andf0)==ANDF0_0x50) {           //ynec
        status = (xy.y != rev4bits[opcode.and0f]) ? 1 : 0;
    } else if((opcode.andf0)==ANDF0_0x60) {           //tcmiy
        dataMemory[xy.both] = rev4bits[opcode.and0f];xy.y += 1;
    } else if(opcode.all==0x7f) {               //cla
        a=0;
    } else if((opcode.andf0)==ANDF0_0x70) {           //iac, axaac
        a += axaac[opcode.and0f];status = (a > 15) ? 1 : 0;a = a & 0xF;
    }
} else if((opcode.and20)) {                     //001xxxxx = $20-$3F
    if(!(opcode.and10)) {                       //0010xxxx = $20-$2F
        if((opcode.andf8)==ANDF8_0x28) {              //ldx
            xy.x=rev3bits[opcode.and07];
        } else {
            switch(opcode.all) {
            case 0x20:                          /* tay */
                xy.y = a;break;

            case 0x21:                          /* tma */
                a = dataMemory[xy.both];break;

            case 0x22:                          /* tmy */
                xy.y = dataMemory[xy.both];break;

            case 0x23:                          /* tya */
                a = xy.y;break;

            case 0x24:                          /* tamdyn */
                dataMemory[xy.both] = a;status = (xy.y >= 1) ? 1 : 0;xy.y -= 1;break;

            case 0x25:                          /* tamiyc */
                dataMemory[xy.both] = a;status = (xy.y == 15) ? 1 : 0; xy.y += 1;break;

            case 0x26:                          /* tamza */
                dataMemory[xy.both] = a;a = 0;break;

            case 0x27:                          /* tam */
                dataMemory[xy.both] = a;break;
            }
        }
    } else {                                    //0011xxxx = $30-$3F
        if((opcode.andfc)==ANDFC_0x30) {          //sbit
            dataMemory[xy.both] |= rev2bitspow2[opcode.and03];
        } else if((opcode.andfc)==ANDFC_0x34) {   //rbit
            dataMemory[xy.both] &= ~rev2bitspow2[opcode.and03];
        } else if((opcode.andfc)==ANDFC_0x38) {   //tbit
            status = ((dataMemory[xy.both] & rev2bitspow2[opcode.and03]) != 0) ? 1 : 0;
        } else {
            switch(opcode.all) {
            case 0x3c:                          /* saman */
                status = (a <= dataMemory[xy.both]) ? 1 : 0;a = (a ^ 0xF) + 1 + dataMemory[xy.both];a = a & 0xF;break;

            case 0x3d:                          /* cpaiz */
                status = (a == 0) ? 1 : 0;a = ((a ^ 0xF) + 1) & 0xF;break;

            case 0x3e:                          /* imac */
                status = (dataMemory[xy.both] == 15) ? 1 : 0;a = (dataMemory[xy.both]+1) & 0xF;break;

            case 0x3f:                          /* mnez */
                status = (dataMemory[xy.both] != 0) ? 1 : 0;break;
            }
        }
    }
} else {                                        //000xxxxx = $00-$1F
    if((opcode.andf0)==ANDF0_0x10) {                  //ldp
        pb=rev4bits[opcode.and0f];
    } else {
        switch(opcode.all) {
        case 0x0c:                              /* rstr */
            if(xy.x <= 3) {
                if(xy.y<8)
                    LATD&=rstrbits[xy.y];
                else
                    LATE&=rstrbits[xy.y];
            }
            break;

        case 0x0d:                              /* setr */
            if(xy.x <= 3) {
                if(xy.y<8)
                    LATD|=setrbits[xy.y];
                else
                    LATE|=setrbits[xy.y];
            }
            break;

            case 0x00:                              /* mnea */
            status = (dataMemory[xy.both] != a) ? 1 : 0;break;

        case 0x01:                              /* alem */
            status = (a <= dataMemory[xy.both]) ? 1 : 0;break;

        case 0x02:                              /* ynea */
            status = sl = ((xy.y != a) ? 1 : 0);break;

        case 0x03:                              /* xma */
            _temp = dataMemory[xy.both];dataMemory[xy.both] = a;a = _temp;break;

        case 0x04:                              /* dyn */
            status = (xy.y >= 1) ? 1 : 0; xy.y -= 1;break;

        case 0x05:                              /* iyc */
            status = (xy.y == 15) ? 1 : 0;xy.y += 1;break;

        case 0x06:                              /* amaac */
            a = a + dataMemory[xy.both];status = (a > 15) ? 1 : 0;a &= 0xF;break;

        case 0x07:                              /* dman */
            status = (dataMemory[xy.both] >= 1) ? 1 : 0;a = (dataMemory[xy.both] - 1) & 0xF;break;

        case 0x08:                              /* tka */
            a= PORTB & 0x7;break;

        case 0x09:                              /* comx */
            xy.x ^= 4;break;

        case 0x0a:                              /* tdo */
            LATA=opla[(((sl != 0) ? 0x10: 0) | a)&0x1f];break;

        case 0x0b:                              /* comc */
            cb ^= 1;break;

        case 0x0e:                              /* knez */
            status = ((PORTB & 0x7) != 0) ? 1 : 0;break;

        case 0x0f:                              /* retn */
            if (cl != 0){
                pc = sr;pa = pb;ca = cs;
                cl = 0;
            } else {
                pa = pb;
            }
            break;
        } //switch 00-0f
    } // not $1x
} //00-1f
